import SortedItems from './structure/SortedItems';
import Dragger from './Dragger';
import { ResultDNDConfig, ResultConfig, Containers, ContainerDimension } from '../../types';
declare class Container {
    id: string;
    el: HTMLElement;
    containers: Containers;
    children: SortedItems<Dragger>;
    dndConfig: ResultDNDConfig;
    containerConfig: ResultConfig;
    dimension: ContainerDimension;
    parentContainer: Container | null;
    constructor({ el, containers, dndConfig, containerConfig, }: {
        el: HTMLElement;
        containers: Containers;
        dndConfig: ResultDNDConfig;
        containerConfig: ResultConfig;
    });
    sorter(a: Dragger, b: Dragger): number;
    addDirectChild(dragger: Dragger): void;
    cleanup(): void;
}
export default Container;
