import Immutable from 'immutable';
import { ContentState } from 'draft-js';
import { ContentBlockNode, BlockNodeMap } from '../../types';
declare const BlockUtil: {
    /**
     * Normally, it will insert a new line block with the same level...
     */
    insertNewLine(): void;
    /**
     * https://github.com/facebook/draft-js/blob/master/src/model/transaction/splitBlockInContentState.js#L90
     * Append a new empty line after all the blocks.
     * 1. Remember current selection
     * 2. Add a new empty block
     * 3. reset selection
     */
    insertNewLineAfterAll(currentState: ContentState): any;
    removeEmptyLineAfterAll(): void;
    insertDelimiter(): void;
    blocksBefore(blockMap: BlockNodeMap, block: ContentBlockNode): Immutable.Seq.Keyed<string, ContentBlockNode>;
    blocksAfter(blockMap: BlockNodeMap, block: ContentBlockNode): Immutable.Seq.Keyed<string, ContentBlockNode>;
    transformBlock: (key: string | undefined, blockMap: BlockNodeMap, func: Function) => any;
    getChildrenAfterRemoveBlock: (parentBlock: ContentBlockNode, block: ContentBlockNode) => Immutable.List<string>;
    getChildrenSize: (parentBlock: ContentBlockNode | undefined) => number | undefined;
    getChildrenBlocks(blockMap: BlockNodeMap, parentBlock: ContentBlockNode): Immutable.OrderedMap<string, ContentBlockNode>;
};
export default BlockUtil;
